package com.company;

public class Player {
    private byte[][] playerCoordinate;

    public Player(){
        playerCoordinate = new byte[6][6];
    }

    public byte[][] getarr() {
        return playerCoordinate;
    }

    public boolean containsInArray(byte[][] arr, int x, int y){
        if (arr[x][y] != 0)
            return true;
        else
            return false;
    }

    public void addDisc(byte[][] arr, byte[][]arrOpponent, int x, int y){
        if ((!containsInArray(arr, x, y)) && (!containsInArray(arrOpponent, x, y)))
            arr[x][y]++;
    }

    public boolean searchIfMatchEnds(byte[][] arr){
        for (int i = 0; i < 6; i++){
            for (int j = 0; j < 6; j++){
                if (containsInArray(arr, j, i)){
                    if (checkSides(j, i))
                        return true;
                }
            }
        }
        return false;
    }

    public boolean checkSides(int x, int y){
        if (x != 0){
            if (containsInArray(playerCoordinate, x - 1, y)){
                if (countTheMoves(x, y, -1, 0) == 5)
                    return true;
            }
            if (y != 0){
                if (containsInArray(playerCoordinate, x - 1, y - 1))
                    if (countTheMoves(x, y, -1, -1) == 5)
                        return true;
            }
            if (y != 5){
                if (containsInArray(playerCoordinate, x - 1, y + 1))
                    if (countTheMoves(x, y, -1, 1) == 5)
                        return true;
            }
        }
        if (x != 5){
            if (containsInArray(playerCoordinate, x + 1, y)){
                if (countTheMoves(x, y, 1, 0) == 5)
                    return true;
            }
            if (y != 0){
                if (containsInArray(playerCoordinate, x + 1, y - 1))
                    if (countTheMoves(x, y, 1, -1) == 5)
                        return true;
            }
            if (y != 5){
                if (containsInArray(playerCoordinate, x + 1, y + 1)) {
                    if (countTheMoves(x, y, 1, -1) == 5)
                        return true;
                }
            }
        }
        if (y != 0){
            if (containsInArray(playerCoordinate, x, y - 1))
                if (countTheMoves(x, y, 0, -1) == 5)
                    return true;
        }
        if (y != 5){
            if (containsInArray(playerCoordinate, x, y + 1)) {
                if (countTheMoves(x, y, 0, 1) == 5)
                    return true;
            }
        }
        return false;
    }

    public int countTheMoves(int x, int y, int moveX, int moveY){
        int x1 = x + moveX;
        int y1 = y + moveY;
        int counter = 1;
        while ((counter < 5) && (x1 > -1) && (x1 < 6)
                && (y1 > -1) && (y1 < 6) && (containsInArray(playerCoordinate, x1, y1))){
            counter++;
            x1 += moveX;
            y1 += moveY;
        }
        return counter;
    }

    public void display(byte[][] arr, byte[][]arr2){
        System.out.println("  0  1  2 3  4 5");
        for (int i = 0; i < 3; i++){
            System.out.print(i + "|");
            for (int j = 0; j < 6; j++){
                if (containsInArray(arr, j, i))
                    System.out.println("R");
                else {
                    if (containsInArray(arr2, j, i))
                        System.out.println("B");
                    else
                        System.out.print("\uD83D\uDD34");
                }
                if ((j == 2) || (j == 5))
                    System.out.print("|");
                else
                    System.out.print(" ");
            }
            System.out.println();
        }
        System.out.print("  ");
        for (int j = 1; j < 15; j++)
            System.out.print("_");
        System.out.println();
        for (int i = 3; i < 6; i++) {
            System.out.print(i + "|");
            for (int j1 = 0; j1 < 6; j1++) {
                if (containsInArray(arr, j1, i))
                    System.out.println("R");
                else {
                    if (containsInArray(arr2, j1, i))
                        System.out.println("B");
                    else
                        System.out.print("\uD83D\uDD34");
                }
                if ((j1 == 2) || (j1 == 5))
                    System.out.print("|");
                else
                    System.out.print(" ");
            }
            System.out.println();
        }
    }

    public void rotate(byte boardNumber){
        byte[] bytes = new byte[2];
        bytes = searchCoordinate(boardNumber);
        byte tmp = playerCoordinate[bytes[0] + 2][bytes[1]];
        playerCoordinate[bytes[0] + 2][bytes[1]] = playerCoordinate[bytes[0]][bytes[1]];
        byte tmp1 = playerCoordinate[bytes[0] + 2][bytes[1] + 2];
        playerCoordinate[bytes[0] + 2][bytes[1] + 2] = tmp;
        byte tmp2 = playerCoordinate[bytes[0]][bytes[1] + 2];
        playerCoordinate[bytes[0]][bytes[1] + 2] = tmp1;
        playerCoordinate[bytes[0]][bytes[1]] = tmp2;

        tmp = playerCoordinate[bytes[0] + 1][bytes[1]];
        playerCoordinate[bytes[0] + 1][bytes [1]] = playerCoordinate[bytes[0]][bytes[1] + 1];
        tmp1 = playerCoordinate[bytes[0] + 2][bytes[1] + 1];
        playerCoordinate[bytes[0] + 2][bytes[1] + 1] = tmp;
        tmp2 = playerCoordinate[bytes[0] + 1][bytes[1] + 2];
        playerCoordinate[bytes[0] + 1][bytes[1] + 2] = tmp1;
        playerCoordinate[bytes[0]][bytes[1] + 1] = tmp2;
    }

    public byte[] searchCoordinate(byte boardNumber){
        byte[] c = new byte[2];
        switch (boardNumber){
            case 1:
                c[0] = 0;
                c[1] = 0;
                break;
            case 2:
                c[0] = 3;
                c[1] = 0;
                break;
            case 3:
                c[0] = 0;
                c[1] = 3;
                break;
            case 4:
                c[0] = 3;
                c[1] = 3;
                break;
        }
        return c;
    }
}


